<?php

namespace App\Classes\Jobs\Commands\V2;

use App\Classes\Modules\KeyValuePairs\DataTransferObjects\KeyValuePairObject;
use App\Classes\Modules\KeyValuePairs\Services\CreatesKeyValuePair;
use App\Classes\Modules\KeyValuePairs\Services\UpdatesKeyValuePair;
use App\Classes\ValueObjects\Constants\KVPKey;
use Carbon\Carbon;
use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Foundation\Bus\Dispatchable;
use Illuminate\Queue\InteractsWithQueue;
use Illuminate\Queue\SerializesModels;
use App\Models\Transaction;
use Illuminate\Support\Facades\Log;
use PhpOffice\PhpSpreadsheet\Shared\Date;


class ProcessSalesDepositByWalletPaymentEntryV2CommandJob implements ShouldQueue
{
    use Dispatchable, InteractsWithQueue, Queueable, SerializesModels;

    /** @var array */
    private $details;

    /**
     * ProcessSalesDepositByWalletPaymentEntryV2CommandJob constructor.
     * @param array $details
     */
    public function __construct(array $details)
    {
        $this->details = $details;
    }

    public function handle()
    {
        Log::info(Carbon::now() . ': Start job - Processing single record from 01DRW - Sales Deposit by Wallet [AR PAYMENT ENTRY] Import.');
        $start   = new Carbon();

        $docNo         = $this->details['docno'] ?? null;
        $docDate       = $this->details['docdate'] ?? null;
        $debtorCode    = $this->details['debtorcode'] ?? null;
        $description   = $this->details['description'] ?? null;
        $paymentMethod = $this->details['paymentmethod'] ?? null;
        $paymentAmt    = $this->details['paymentamt'] ?? null;

        Log::info("Processing Sales Deposit By Wallet [Payment Entry] Report:", [
            'DocNo' => $docNo,
            'DocDate' => $docDate,
            'DebtorCode' => $debtorCode,
            'Description' => $description,
            'PaymentMethod' => $paymentMethod,
            'PaymentAmt' => $paymentAmt,
        ]);

        $transaction = Transaction::where('bill_no', $description)->first();
        if($transaction){
            if($docNo != "" && $docNo != "<<New>>"){
                $this->updateOrCreateKeyValuePair($transaction, KVPKey::AUTOCOUNT_DOCNO_SALES_DEPOSIT_BY_WALLET_OFFICIAL_RECEIPT, $docNo);
            }
            // if($docDate){
            //     $this->updateOrCreateKeyValuePair($transaction, KVPKey::AUTOCOUNT_DOCDATE_OFFICIAL_RECEIPT, is_numeric($docDate) ? $this->convertDocDateToString($docDate) : $docDate);
            // }
        }

        $end = new Carbon();
        $elapsedTime = $start->diff($end)->format('%H:%I:%S');
        Log::info(Carbon::now() . ': End job - Processing single record from 01DRW - Sales Deposit by Wallet [AR PAYMENT ENTRY] Import. ElapsedTime: ' . $elapsedTime . '.');
    }


    private function updateOrCreateKeyValuePair($booking, $key, $value)
    {
        $keyValuePairObject = new KeyValuePairObject($key, $value);
        $metadata = $booking->attributesKVP()->where('key', $key)->first();

        if ($metadata) {
            (App()->make(UpdatesKeyValuePair::class))->execute($metadata, $keyValuePairObject);
        } else {
            (App()->make(CreatesKeyValuePair::class))->execute($booking, $keyValuePairObject);
        }
    }

    private function convertDocDateToString($value, $format = 'm/d/Y') {
        if (is_numeric($value)) {
            return Carbon::instance(Date::excelToDateTimeObject($value))->format($format);
        }
        return Carbon::parse($value)->format($format);
    }
}
